"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var isArray_1 = __importDefault(require("lodash/fp/isArray"));
var mergeWith_1 = __importDefault(require("lodash/fp/mergeWith"));
var puppeteer_1 = __importDefault(require("puppeteer"));
var HTMLToPDF = /** @class */ (function () {
    function HTMLToPDF(html, options) {
        this._options = {
            browserOptions: {
                args: ['--font-render-hinting=none'],
            },
            pdfOptions: {
                printBackground: true,
            },
            waitForNetworkIdle: false,
        };
        this.mergeOptions = mergeWith_1.default(function (objValue, srcValue) {
            if (isArray_1.default(objValue)) {
                if (srcValue.length === 0) {
                    return objValue = srcValue;
                }
                return objValue.concat(srcValue);
            }
        });
        if (options) {
            this._options = this.mergeOptions(this._options, options);
        }
        this._html = html;
    }
    Object.defineProperty(HTMLToPDF.prototype, "html", {
        set: function (html) {
            this._html = html;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HTMLToPDF.prototype, "options", {
        set: function (options) {
            this._options = this.mergeOptions(this._options, options);
        },
        enumerable: true,
        configurable: true
    });
    HTMLToPDF.prototype.convert = function () {
        var _this = this;
        return new Promise(function (res, rej) { return __awaiter(_this, void 0, void 0, function () {
            var browser, page, html, pdf, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, puppeteer_1.default.launch(this._options.browserOptions)];
                    case 1:
                        browser = _a.sent();
                        return [4 /*yield*/, browser.newPage()];
                    case 2:
                        page = _a.sent();
                        page.on('error', function (err) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, browser.close()];
                                    case 1:
                                        _a.sent();
                                        rej(err);
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        if (!this._options.waitForNetworkIdle) return [3 /*break*/, 4];
                        html = HTMLToPDF.createDataUri(this._html, 'text/html');
                        return [4 /*yield*/, page.goto(html, { waitUntil: 'networkidle0' })];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, page.setContent(this._html)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        _a.trys.push([6, 9, , 11]);
                        return [4 /*yield*/, page.pdf(this._options.pdfOptions)];
                    case 7:
                        pdf = _a.sent();
                        return [4 /*yield*/, browser.close()];
                    case 8:
                        _a.sent();
                        res(pdf);
                        return [3 /*break*/, 11];
                    case 9:
                        err_1 = _a.sent();
                        return [4 /*yield*/, browser.close()];
                    case 10:
                        _a.sent();
                        rej(new Error("Error whilst generating PDF: " + err_1.message));
                        return [3 /*break*/, 11];
                    case 11: return [2 /*return*/];
                }
            });
        }); });
    };
    HTMLToPDF.createDataUri = function (data, mimeType) {
        var asBuffer = data instanceof Buffer ? data : Buffer.from(data);
        var asBase64 = asBuffer.toString('base64');
        return "data:" + mimeType + ";base64," + asBase64;
    };
    return HTMLToPDF;
}());
exports.default = HTMLToPDF;
